#include "system.h"
#include "wifi.h"
#include "web.h"
#include "mqtt.h"
#include "lux.h"

#include <stdio.h>
#include <FreeRTOS.h>
#include <task.h>

#include <espressif/esp_common.h>
#include <esp/uart.h>

#include "rboot-api.h"

void user_init(void)
{
    uart_set_baud(0, 115200);
    printf("SDK version: %s\n", sdk_system_get_sdk_version());

    sdk_wifi_set_sleep_type(WIFI_SLEEP_MODEM);

    system_init_config();

    wifi_available_semaphore = xSemaphoreCreateBinary();

    xTaskCreate(wifi_task, "wifi_task", 1024, NULL, 1, NULL);

    xTaskCreate(&httpd_task, "httpd_task", 1024, NULL, 2, NULL);

    xTaskCreate(&lux_task, "lux_task", 512, NULL, 1, NULL);

    rboot_config conf = rboot_get_config();
    printf("\r\n\r\nOTA Basic demo.\r\nCurrently running on flash slot %d / %d.\r\n\r\n",
           conf.current_rom, conf.count);

    printf("Image addresses in flash:\r\n");
    for(int i = 0; i <conf.count; i++) {
        printf("%c%d: offset 0x%08x\r\n", i == conf.current_rom ? '*':' ', i, conf.roms[i]);
    }

    printf("profit!\n");
}
